/*
 * Created on Oct 15, 2004
 */
package tddSample;
import junit.framework.TestCase;

/**
 * @author Administrator
 */
public class TriangleTest extends TestCase {
    private Triangle t111;
    private Triangle t000;
    private Triangle t235;
    private Triangle t2310;
    private Triangle t754;
    private Triangle tm154;
    private Triangle t123;
    private Triangle t221;
    private Triangle t212;
    private Triangle t122;
    private Triangle t567;
    private Triangle t345;
    private Triangle t354;
    private Triangle t543;
    
    public void testIsValid() {
        assertTrue(t111.isValid());
        assertFalse(t000.isValid());
        assertFalse(t235.isValid());
        assertFalse(t2310.isValid());
        assertTrue(t754.isValid());
        assertFalse(tm154.isValid());
    }

    public void testIsEquilateral() {
        assertTrue(t111.isEquilateral());
        assertFalse(t754.isEquilateral());
        assertFalse(t000.isEquilateral());
        assertFalse(tm154.isEquilateral());
        assertFalse(t235.isEquilateral());
        assertFalse(t123.isEquilateral());
    }

    protected void setUp() throws Exception {
        super.setUp();
        t111 = new Triangle(1,1,1);
        t000 = new Triangle(0,0,0);
        t235 = new Triangle(2,3,5);
        t2310 = new Triangle(2,3,10);
        t754 = new Triangle(7,5,4);
        tm154 = new Triangle(1,5,4);
        t123 = new Triangle(1,2,3);
        t122 = new Triangle(1,2,2);
        t221 = new Triangle(2,2,1);
        t212 = new Triangle(2,1,2);
        t567 = new Triangle(5,6,7);
        t345 = new Triangle(3,4,5);
        t354 = new Triangle(3,5,4);
        t543 = new Triangle(5,4,3);
    }

    public void testIsIsosceles() {
        assertTrue(new Triangle(2,2,3).isIsosceles());
        assertFalse(t754.isIsosceles());
        assertFalse(t111.isIsosceles());
        assertTrue(t122.isIsosceles());
        assertTrue(t212.isIsosceles());
        assertTrue(t221.isIsosceles());
        assertFalse(t000.isIsosceles());
        assertFalse(t235.isIsosceles());
    }

    public void testIsScalene() {
        assertFalse(t111.isScalene());
        assertFalse(t000.isScalene());
        assertFalse(t235.isScalene());
        assertFalse(t2310.isScalene());
        assertTrue(t754.isScalene());
        assertFalse(tm154.isScalene());
        assertFalse(t123.isScalene());
        assertFalse(t122.isScalene());
        assertFalse(t221.isScalene());
        assertFalse(t212.isScalene());
        assertTrue(t567.isScalene());
    }

    public void testIsPerpendicular() {
        assertTrue(t345.isPerpendicular());
        assertFalse(t111.isPerpendicular());
        assertFalse(t567.isPerpendicular());
        assertFalse(t122.isPerpendicular());
        assertFalse(t212.isPerpendicular());
        assertFalse(t221.isPerpendicular());
        assertTrue(t354.isPerpendicular());
        assertTrue(t543.isPerpendicular());
    }
}
